{ͻ
  Unit      _Fehler.pas                                  
                                                         
  Compiler  Turbo Pascal 6.0                             
                                                         
  Date      18.02.90                                     
                                                         
  Update    29.04.90                                     
                                                         
  Autor     Reiner Schlles                              
 Ķ
  Inhalt    Fehlerbehandlungs-Routinen.                  
 ͼ}
Unit _Fehler;
{ͻ
  Interface (ffentlicher Teil)                           
 ͼ}
Interface
uses {Einzubindende Bibliotheken}
  _Declare;                        {Unit aus dem Unitsystem}

  {Verzeichnis der globalen Routinen}

  function _ErrorResult: byte;
  function _ErrorMld(Nr: byte): _WorkStr;

{ͻ
  Implementation (Nicht-ffentlicher Teil)                
 ͼ}
Implementation

{ͻ
  _ErrorResult                                            
 Ķ
  Liefert die Nummer des aufgetretenen Fehlers zurck, der
  in der globalen Variablen _Error nach Abarbeitung ent-  
  sprechender Routinen gespeichert wurde. Das Ergebnis 0  
  steht fr fehlerfreie Ausfrhrung. Nach Abarbeitung     
  dieser Routine wird _Error wieder auf 0 gesetzt.        
 ͼ}
function _ErrorResult: byte;
begin
  _ErrorResult:= _Error;
  _Error:= 0;
end;
{ͻ
  _ErrorMld                                               
 Ķ
  Zu jeder Fehlermeldung der Variablen _Error gibt es     
  einen entsprechenden Fehlertext, der als Ergebnis dieser
  Funktion zurckgeliefert wird.                          
 ͼ}
function _ErrorMld(Nr: byte): _WorkStr;
var str: _WorkStr;

begin
  case Nr of
      0: str:= '0: Operation wurde fehlerfrei ausgefhrt! ';
      1: str:= '1: Datei nicht vorhanden! ';
      2: str:= '2: Quelldatei nicht vorhanden! ';
      3: str:= '3: Zieldatei nicht vorhanden! ';
      4: str:= '4: Zieldatei bereits vorhanden! ';
      5: str:= '5: Ungltiger Dateiname! ';

     10: str:= '10: String zu lang (<79 Zeichen)! ';

     20: str:= '20: Keine Integerzahl! ';
     21: str:= '21: Keine Realzahl! ';
  end;
  _ErrorMld:= ' Fehler ' + str;
end;
{ͻ
  End of Unit                                             
 ͼ}
end.